<?php 
$this->layout("layouts/learn", $serviceOffering);
$this->start("nav-tabs");
echo "<li class=\"active\" role=\"presentation\">\n    <a aria-controls=\"home\" data-toggle=\"tab\" href=\"#about\" role=\"tab\">About</a>\n</li>\n<li role=\"presentation\">\n    <a aria-controls=\"automation\" data-toggle=\"tab\" href=\"#automation\" role=\"tab\">Automation</a>\n</li>\n<li role=\"presentation\">\n    <a aria-controls=\"pricing\" data-toggle=\"tab\" href=\"#pricing\" role=\"tab\">Pricing</a>\n</li>\n<li role=\"presentation\">\n    <a aria-controls=\"faq\" data-toggle=\"tab\" href=\"#faq\" role=\"tab\">FAQ</a>\n</li>\n";
$this->end();
$this->start("content-tabs");
echo "<div class=\"tab-pane active symantec\" id=\"about\" role=\"tabpanel\">\n    <div class=\"content-padded\">\n        <h3>The World's #1 Security Solution</h3>\n        <h2>Symantec is the most recognized & trusted SSL certificate brand the world</h2>\n        <p>Symantec along with their brands RapidSSL and GeoTrust are some of the most widely recognised SSL products on the market, with the highest recognition among consumers and a range of solutions to fit every budget.</p>\n        <div class=\"features-overview\">\n            <div class=\"row\">\n                <div class=\"col-sm-1\">\n                    <i class=\"fa fa-file-text-o fa-3x\"></i>\n                </div>\n                <div class=\"col-sm-5\">\n                    <h4>Full suite of SSL Certificates</h4>\n                    <p>Symantec offers the widest range of SSL Certificates to fit every need.</p>\n                </div>\n                <div class=\"col-sm-1\">\n                    <i class=\"fa fa-shield fa-3x\"></i>\n                </div>\n                <div class=\"col-sm-5\">\n                    <h4>Most Recognised Security Seal</h4>\n                    <p>A widely recognised seal that gives customers confidence.</p>\n                </div>\n            </div>\n        </div>\n        <p><small><strong>About Symantec</strong><br>Since 1991, Symantec has powered the world-renowned anti-virus brand, Norton, and the Symantec name and brand has become synonymous with internet security.  Symantec is one of the most recognised brands among consumers and in 2010, they acquired VeriSign and today are the #1 choice in Internet Security.</small></p>\n        <div class=\"row row-logos\">\n            <div class=\"col-sm-4 col-sm-offset-2 text-center\">\n                <img src=\"../assets/img/marketconnect/symantec/rapidssl-logo.png\" height=\"40\">\n            </div>\n            <div class=\"col-sm-4 text-center\">\n                <img src=\"../assets/img/marketconnect/symantec/geotrust-logo.png\" height=\"40\">\n            </div>\n        </div>\n    </div>\n</div>\n<div class=\"tab-pane symantec\" id=\"automation\" role=\"tabpanel\">\n    <div class=\"content-padded\">\n        <h3>Fully Automated from Purchase to Provisioning</h3>\n        <h4>SSL Selling is faster and more efficient with WHMCS MarketConnect</h4>\n        <br>\n        <div class=\"row\">\n            <div class=\"col-sm-6\">\n                <ul>\n                    <li><i class=\"fa fa-check\"></i> Fully automated DV SSL Issuance</li>\n                    <li><i class=\"fa fa-check\"></i> Automatic Installation with cPanel</li>\n                    <li><i class=\"fa fa-check\"></i> Less error prone</li>\n                </ul>\n            </div>\n            <div class=\"col-sm-6\">\n                <ul>\n                    <li><i class=\"fa fa-check\"></i> Seamless automation</li>\n                    <li><i class=\"fa fa-check\"></i> Increased renewal rates</li>\n                    <li><i class=\"fa fa-check\"></i> No reliance on manual interaction</li>\n                </ul>\n            </div>\n        </div>\n    </div>\n    <div class=\"symantec-ee\">\n        <div class=\"row\">\n            <div class=\"col-sm-8\">\n                <div class=\"inner\">\n                    <span>Faster and simpler domain validation reduces costs and increases customer satisfaction</span>\n                    <br><br>\n                    Automation leads to less reliance on manual processes which should lead to lower support calls and save on time and administration. A better, simpler, streamlined experience leading to near automatic issuance of certificates, allowing customers to get their security solution in place more quickly.\n                </div>\n            </div>\n            <div class=\"col-sm-4 text-right\">\n                <img src=\"../assets/img/marketconnect/symantec/symantec-ee-icon.png\">\n            </div>\n        </div>\n    </div>\n</div>\n<div class=\"tab-pane symantec\" id=\"pricing\" role=\"tabpanel\">\n    <div class=\"content-padded\">\n        ";
if( $feed->isNotAvailable() ) 
{
    echo "            <div class=\"pricing-login-overlay\">\n                <p>To view pricing, you must first register or login to your MarketConnect account.</p>\n                <button type=\"button\" class=\"btn btn-default btn-sm btn-login\">Login</button> <button type=\"button\" class=\"btn btn-default btn-sm btn-register\">Create Account</button>\n            </div>\n        ";
}

echo "        <table class=\"table table-pricing\">\n            <tr>\n                <th>Certificate</th>\n                <th>Your Cost Price</th>\n                <th>Symantec Retail</th>\n                <th>Warranty</th>\n                <th>Validation</th>\n                <th>Issuance</th>\n                <th>Green Bar</th>\n                <th>Seal</th>\n            </tr>\n";
foreach( $promotionHelper->getCertificateFeatures() as $certId => $certificate ) 
{
    echo "\n            <tr>\n                <td>" . $certificate["displayName"] . "</td>\n                <td>" . $feed->getCostPrice($certId) . "</td>\n                <td>\$" . $certificate["retail"] . "</td>\n                <td>\$" . $certificate["warranty"] . "</td>\n                <td>" . $certificate["validation"] . "</td>\n                <td class=\"issuance\">" . $certificate["issuance"] . "</td>\n                <td>" . (($certificate["ev"] ? "Yes" : "-")) . "</td>\n                <td>" . $certificate["seal"] . "</td>\n            </tr>\n    ";
}
echo "</table>\n    </div>\n</div>\n<div class=\"tab-pane\" id=\"faq\" role=\"tabpanel\">\n    <div class=\"content-padded weebly faq\">\n        <h4>Why should I offer SSL Certificates?</h4>\n        <p>Web pages not served via HTTPS will soon be marked ‘not secure’ in Google Chrome and Mozilla Firefox. SSL is no longer optional and so offering SSL Certificates is another service you can offer to your customers.</p>\n        <h4>How long do SSL Certificates take to be issued?</h4>\n        <p>DV SSL Certificates are typically issued in minutes. OV and EV SSL Certificates can take up to 2-5 days as they require manual verification and checks to be completed.</p>\n        <h4>How does the automated SSL installation work?</h4>\n        <p>WHMCS MarketConnect supports interfacing with cPanel to automatically provision and install SSL certificates to cPanel hosting accounts. WHMCS and MarketConnect will take care of the domain ownership verification using File Based Authentication and install the certificate to the site upon issue by Symantec.</p>\n        <h4>Do Symantec SSL Certificates include a site seal?</h4>\n        <p>Yes, all Symantec Paid SSL Certificates include a site seal that users can display on their website. Most free SSL Certificates do not include this.</p>\n    </div>\n</div>\n<div class=\"tab-pane\" id=\"activate\" role=\"tabpanel\">\n    ";
$this->insert("shared/configuration-activate", array( "currency" => $currency, "service" => $service, "firstBulletPoint" => "Offer all RapidSSL, GeoTrust & Symantec Certificates", "landingPageRoutePath" => "store-ssl-certificates-index", "serviceOffering" => $serviceOffering, "billingCycles" => $billingCycles, "products" => $products, "serviceTerms" => $serviceTerms ));
echo "</div>\n";
$this->end();

